  use32 		;  32-  
  org	 0		;   

  db	 'MENUET01'	; 8-  MenuetOS
  dd	 1		;   ( 1)
  dd	 start		;   
  dd	 i_end		;  
  dd	 mem		;  
  dd	 stack_top	;   
  dd	 0		;    
  dd	 0		;        

include '../include/macros.inc'

WIN_W	  equ 80
WIN_H	  equ 20
WIN_COLOR equ 7C99FFh

WM_SIZE   equ 250

start:
	mcall	14
	mov	[ScreenY],ax
	shr	eax,16
	mov	[ScreenX],ax

	call	FillDatWinds

      @@:		;       
	mcall	5,10	   ;sleep 10ms
	cmp	[bDlgActive],1
	je	@b
	mcall	37,0	   ;get mouse position
	test	ax,ax
	jnz	@b
	shr	eax,16
	cmp	ax,[ScreenX]
	jne	@b
	mov	[bDlgActive],1
	mcall	51,1,startWin,win_stack

	jmp	@b
	
;----------------------------------------------------------------
;    4    .
;     .       
align 4
startWin:
	mcall	40,101b

align 4
redraw:
	mcall	12,1

			      ; 
	mov	bx,[ScreenX]
	sub	ebx,WIN_W
	shl	ebx,16
	mov	bx,WIN_W
	mov	ecx,WIN_H
	mov	edx,61000000h+WIN_COLOR
	xor	eax,eax
	mcall

			; 
	mov	eax,8
	mov	ebx,WIN_H*3*10000h+WIN_H
	mov	ecx,WIN_H
	mov	edx,4
	mov	esi,WIN_COLOR
     .DrawBut:

	mcall
	sub	ebx,WIN_H*10000h
	dec	edx
	jnz	.DrawBut

	mcall	12,2

align 4
messages:
	mcall	23,5

	dec	eax
	jz	redraw
	dec	eax
	dec	eax
	jz	button

	mcall	37,0
	mov	dx,[ScreenX]
	sub	dx,WIN_W
	cmp	ax,WIN_H
	ja	exit
	shr	eax,16
	cmp	ax,dx
	jb	exit

	jmp	messages


;---------------------------------------------------------------------
align 4
button:
	mcall	17

	cmp	ah,[numDeskt]
	je	exit
	push	eax
	call	FillDatWinds	
	pop	eax

	mov	al,ah
	and	eax,0FFh
	call	SelectDeskt
	jmp	messages

;-------------------------------------------------------------------------------
align 4
exit:
	mov	[bDlgActive],0
	mcall	-1

;mcall  18,3,slot -  
;mcall  18,7   - ,  
;mcall  18,21,pid = slot
;mcall  18,22,0(min,slot)/1(min,pid)/2(rest,slot)/3(rest,pid)

;-------------------------------------------------------------------------------
SelectDeskt:	  ;eax=selected desktop
	push	eax		


	mcall	9,ProcInfo,-1		;  ,      
	mov	[MaxProc],eax
	m2m	dword[MyPID],dword[ProcInfo.PID]



;------------------------------  ;
	mcall	18,23 		; ,  ,   

;	movzx	ecx,[numDeskt]
;	mov	esi,WinMin
;     @@:
;	add	esi,WM_SIZE*4
;	loop	@b
;	sub	esi,WM_SIZE*4
;
;	mov	ecx,WM_SIZE
;.doMinimize:
;	mov	edx,[esi]
;	test	edx,edx
;	jz	@f
;	push	ecx
;	mcall	18,22,1
;	pop	ecx
;    @@:
;	add	esi,4
;	loop	.doMinimize

;------------------------------ ;


	pop	ecx		;selected desktop
	mov	[numDeskt],cl
	mov	esi,WinMin
     @@:
	add	esi,WM_SIZE*4
	loop	@b
	sub	esi,WM_SIZE*4

	mov	ecx,WM_SIZE
.doRestore:
	mov	edx,[esi]
	test	edx,edx
	jz	@f
	push	ecx
	mcall	18,22,3
	pop	ecx
     @@:
	add	esi,4
	loop	.doRestore


	ret

;-------------------------------------------------------------------------------
align 4
FillDatWinds:	    ; WinActive  WinMin.  c 
	xor	ecx,ecx
	mov	cl,[numDeskt]
	mov	esi,WinMin
     @@:
	add	esi,WM_SIZE*4
	loop	@b
	sub	esi,WM_SIZE*4

	mcall	9,ProcInfo,-1		;  PID
	mov	[MaxProc],eax
	m2m	dword[MyPID],dword[ProcInfo.PID]

	xor	ecx,ecx
	mov	cl,[numDeskt]

	mov	ecx,2 ;  slot
	mov	ebx,ProcInfo
align 4
     .GetProcI:				;   .  -  ,   
	mcall	9     ;,ProcInfo,ecx    ;   
	cmp	word[ProcInfo.slot_state],9
	je	@f
	mov	eax,dword[ProcInfo.PID]
	cmp	eax,[MyPID]
	je	@f
	cmp	byte[ProcInfo.process_name],'@'
	je	@f
	cmp	dword[ProcInfo.box.width],0
	je	@f
	cmp	dword[ProcInfo.box.height],0
	je	@f
	test	byte[ProcInfo.wnd_state],10b
	jnz	@f

	mov	[esi],eax
	add	esi,4
      @@:
	inc	ecx
	cmp	ecx,[MaxProc]
	jbe	.GetProcI

	mov	dword[WinMin+esi],0

	ret

;---------------------------------------------------------------------
;---    --------------------------------------------------------
;---------------------------------------------------------------------
align 4
bDlgActive	dd 0	    ;  ,   ,    
numDeskt	db 1	   ;   ( 1)


i_end:

;-------------------------------------------------------------------------------
;---------   -----------------------------------------
;-------------------------------------------------------------------------------
MaxProc 	rd 1
MyPID		rd 1

align 4
WinMin		rd WM_SIZE*4   ;PIDs  ;  .  4 
				;      

ProcInfo	 process_information

align 4
ScreenX 	rw 1
ScreenY 	rw 1

	rd 256
win_stack:
	rd 256	  ;stack
stack_top:

mem:

